// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { CanTransferQuery, CanTransferQueryResponse } from "./CanTransferQuery";
import { QueryHandler } from "../../../../../core/decorator/QueryHandlerDecorator";
import { RPCQueryAdapter } from "../../../../../port/out/rpc/RPCQueryAdapter";
import { lazyInject } from "../../../../../core/decorator/LazyInjectDecorator";
import SecurityService from "../../../../service/security/SecurityService";
import ValidationService from "../../../../service/validation/ValidationService";
import AccountService from "../../../../service/account/AccountService";
import BigDecimal from "../../../../../domain/context/shared/BigDecimal";
import { EMPTY_BYTES } from "../../../../../core/Constants";
import ContractService from "../../../../service/contract/ContractService";
import { CanTransferQueryError } from "./error/CanTransferQueryError";
let CanTransferQueryHandler = class CanTransferQueryHandler {
    securityService;
    queryAdapter;
    accountService;
    validationService;
    contractService;
    constructor(securityService, queryAdapter, accountService, validationService, contractService) {
        this.securityService = securityService;
        this.queryAdapter = queryAdapter;
        this.accountService = accountService;
        this.validationService = validationService;
        this.contractService = contractService;
    }
    async execute(query) {
        try {
            const { securityId, targetId, amount } = query;
            const securityEvmAddress = await this.contractService.getContractEvmAddress(securityId);
            const targetEvmAddress = await this.accountService.getAccountEvmAddress(targetId);
            const account = this.accountService.getCurrentAccount();
            const security = await this.securityService.get(securityId);
            await this.validationService.checkDecimals(security, amount);
            const amountBd = BigDecimal.fromString(amount, security.decimals);
            const [, res] = await this.queryAdapter.canTransfer(securityEvmAddress, targetEvmAddress, amountBd, EMPTY_BYTES, account.evmAddress);
            return new CanTransferQueryResponse(res);
        }
        catch (error) {
            throw new CanTransferQueryError(error);
        }
    }
};
CanTransferQueryHandler = __decorate([
    QueryHandler(CanTransferQuery),
    __param(0, lazyInject(SecurityService)),
    __param(1, lazyInject(RPCQueryAdapter)),
    __param(2, lazyInject(AccountService)),
    __param(3, lazyInject(ValidationService)),
    __param(4, lazyInject(ContractService)),
    __metadata("design:paramtypes", [SecurityService,
        RPCQueryAdapter,
        AccountService,
        ValidationService,
        ContractService])
], CanTransferQueryHandler);
export { CanTransferQueryHandler };
